                           ;   ATmega 8    
                           ;        
                           ;   2  (  )           
	                       ; : CKSEL0=0,CKSEL1=1,CKSEL2=0,CKSEL3=0,SUT0=0,SUT1=1,SKOPT=1   
                     
	                      ;   

.include "m8def.inc"             ;   

.list                            ;  


.def temp = R16                  ;    
.def step = R17                  ;  -                            
.def rab =  R18                  ;     
.def ADC4 = R19                  ;  -      4  
.def ADC5 = R20                  ;  -      5  
.def st_mot_X = R21              ;  -    
.def rewers   = R22              ;  -     
.def sbros    = R23              ;      2 (  - 0)
.def buf_X    = R24              ;      

      		
                           ;   
     
        .cseg                    ;     (Flesh  )

      
                       ;     ATmega 8


start:   .org $000        
         rjmp   init      ; (RESET) 
         .org $001
         reti             ; (INT0) External Interrupt Request 0
         .org $002
         reti             ; (INT1) External Interrupt Request 1
         .org $003
         rjmp  timer_2    ; (TIMER2 COMP) Timer/Counter2 Compare Match
         .org $004
         reti             ; (TIMER2 OVF) Timer/Counter2 Overflow
         .org $005
         reti		      ; (TIMER1 CAPT) Timer/Counter1 Capture Event
         .org $006
         reti             ; (TIMER1 COMPA) Timer/Counter1 Compare Match A
         .org $007
         reti             ; (TIMER1 COMPB) Timer/Counter1 Compare Match B
         .org $008
         reti             ; (TIMER1 OVF) Timer/Counter1 Overflow
         .org $009
         reti             ; (TIMER0 OVF) Timer/Counter0 Overflow
         .org $00A
         reti             ; (SPI,STC) Serial Transfer Complete
         .org $00B
         reti             ; (USART,RXC) USART, Rx Complete
         .org $00C
         reti             ; (USART,UDRE) USART Data Register Empty
         .org $00D
         reti             ; (USART,TXC) USART, Tx Complete
         .org $00E
         reti		      ; (ADC) ADC Conversion Complete
         .org $00F
         reti             ; (EE_RDY) EEPROM Ready
         .org $010
         reti             ; (ANA_COMP) Analog Comparator 
         .org $011
         reti             ; (TWI) 2-wire Serial Interface
         .org $012        
         reti             ; (SPM_RDY) Store Program Memory Ready

	    .org   INT_VECTORS_SIZE      	;   


                         ;   

init: ldi    YH, high(RAMEND)    ;   c  Y-      "RAMEND" (.  $045F  04)
      ldi    YL, low(RAMEND)     ;     Y-      "RAMEND" (.  $045F  5F)
      out    SPH, YH             ;          
      out    SPL, YL             ;          
   
	  
	                      ;   

      ldi     temp, 0b00001111   
      out     DDRC, temp         ;   C  (0-3 -  , 4-7 -  )        
      ldi     temp, 0  

	  out     DDRB, temp         ;   B  
	  ldi     temp, 0b00000100
	  out     PORTB, temp        ;      2
	  ldi     temp, 0b11100000 
	  out     DDRD, temp         ;   D PD0-PD4 -  , PD5-PD7 -    
	  ldi     temp, 0b00000111   
      out     PORTD, temp        ;      D0-PD2                


                      ;  

	  ldi      temp, 0x80        ;   0b10000000   
      out      ACSR, temp        ;  
      	            
					    ;  2
	  ldi      temp, 0b00001100   ;   0b00001100    
      out      TCCR2,temp         ;    2(    64   CTC)
	 
	             ;     2

	  ldi      temp, 0b10000000  ;      
      out      TIMSK, temp       ;     2 (   )
						 
			 ;       2

	  ldi      sbros, 0            ;   0   sbros
						 
						 
						  ;      ADC5

      ldi      rab, 0b00100101     
      out	   ADMUX, rab          ;      -      ADC5      ADC5
      ldi      rab, 0b11000001     ;      1  (..   2        /2)
	  out      ADCSRA, rab         ;            
fd0:  in       rab, ADCSRA         ;     6  DSC   0 ( ),       ADC5 
	  sbrc     rab, 6              ;       /  2 - OCR2
	  rjmp     fd0
	  in       ADC5, ADCH          	    
	  out      OCR2, ADC5         ;      c ADC5         
						  
                
				  ;     (/)
				                           	  
	  in       temp, PIND          ;         temp
	  sbrc     temp, 0             ;   2     0 ( 0,   .      mic_st)
	  rjmp     diskret	          
	  	  
	           ;     ( - /)
prop:	  
	  in       temp, PINB          ;         temp
	  sbrc     temp, 2             ;   2     0 ( 0,   .      mic_st)
	  rjmp     old_st			   ;  2=1,     old_st	  	  
	  							
mic_st:               ;       ( )

      cli                          ;     
	  	
calibr:                            ;               
	  ldi      rab, 0b00100101     
      out	   ADMUX, rab          ;      -      ADC5      ADC5
      ldi      rab, 0b11000001     ;      1  (..   2        /2)
	  out      ADCSRA, rab         ;            
fd7:  in       rab, ADCSRA         ;     6  DSC   0 ( ),       ADC5 
	  sbrc     rab, 6              ;       /  2 - OCR2
	  rjmp     fd7
	  in       ADC5, ADCH          	    
	  out      OCR2, ADC5         ;      c ADC5 
	  
	  in       temp, PINB          ;        temp     
      sbrc     temp, 1             ;   1     0 ( 0,   . )
	  rjmp     left_end            ;  1=1,       ,       ,     1          
	  clr      st_mot_X            ;  1=0,              .      st_mot_X 
	  rjmp     main                ;      main 
	  				
					;        ( )	   
left_end: 	                        
      ldi      rewers, 1	       ;  1   rewers (             2)  
	  ldi      temp, 0b00001100    ;   0b00001100       
	  out      TCCR2,temp          ;    2 	  
	  
	  sei                          ;      						    	  
	  
	  ldi      step, 0b00000111    ;    step        

l1:   out      PORTC, step  	   ;     step   C -   					
	  
	  ldi      rab, 0b00100101     
      out	   ADMUX, rab          ;      -      ADC5      ADC5
      ldi      rab, 0b11000001     ;      1  (..   2        /2)
	  out      ADCSRA, rab         ;            
fd1:  in       rab, ADCSRA         ;     6  DSC   0 ( ),       ADC5 
	  sbrc     rab, 6              ;       /  2 - OCR2
	  rjmp     fd1
	  in       ADC5, ADCH          	    
	  out      OCR2, ADC5          ;      c ADC5
	  	  
	  in       temp, PINB          ;        temp 					
	  sbrc     temp, 1 			   ; : "        .  1 = 0,       .  		
	  rjmp     l1                  ;  1=1,             l1,     step          
	  clr      st_mot_X            ;  1=0,              .      st_mot_X  	 

j1:	  cli                          ;     					
      ldi      temp, 0b00001000   
      out      TCCR2,temp          ;   -  2
	  out      TCNT2, sbros	       ;     -   2					
							
						 	;         ( )
							  
main: ldi      rab, 0b00100101     
      out	   ADMUX, rab          ;      -      ADC5      ADC5
      ldi      rab, 0b11000001     ;      1  (..   2        /2)
	  out      ADCSRA, rab         ;            
fd2:  in       rab, ADCSRA         ;     6  DSC   0 ( ),       ADC5 
	  sbrc     rab, 6              ;       /  2 - OCR2
	  rjmp     fd2
	  in       ADC5, ADCH   
	  out      OCR2, ADC5          ;      c ADC5
  
	  ldi      rab, 0b00100100     
      out	   ADMUX, rab          ;     -     ADC4      ADC4
      ldi      rab, 0b11000001     ;  X -   -     1  (..   2        /2)
	  out      ADCSRA, rab         ;            
m1:   in       rab, ADCSRA         ;     6  DSC   0 ( ),       ADC4 
	  sbrc     rab, 6              ;     .
	  rjmp     m1
                                  
j2:   cbi      PORTD, 7            ;   PD7 (  )
      cpi      st_mot_X, 0         ;  : "   st_mot_X -    "?
      breq     vd3                 ;  st_mot_X ,     vd3
      cbi      PORTD, 5            ;   st_mot_X  ,   D5
      rjmp     vd4                 ;    vd4

vd3:  sbi      PORTD, 5            ;   st_mot_X  0,    D5 
     
vd4:  in       ADC4, ADCH          ;      ADCH   -  ADC4 
      cpi      ADC4, 0             ;    ADC4  0 
	  breq     j3                  ;     0,    -      ,            ;      j3 
	  rjmp     j4                  ;     0,          j4
j3:	  in       temp, PINB          ;        temp     
      sbrc     temp, 1             ;   1     0 ( 0,   . )
	  rjmp     left_end            ;  1=1,          .    (  left_end)

j4:	  mov      buf_X, st_mot_X     ;   ADC4 > 0,        .          buf_X
      cp       ADC4, buf_X         ;    ADC4  buf_X (..      X -     )
      breq     j1                  ;    ,      -          ,     j1   
      brlo     n1                  ;    ADC4  buf_X,    n1
								   ;        ADC4  buf_X,     ...
                                   
								   ; : "     ADC4  buf_X?" 
	  sub      ADC4,  buf_X        ;     ADC4  buf_X
      cpi      ADC4, 2             ;      2,  ,    (     )
      brsh     f1                  ;    f1     ADC4  buf_X    2 
      rjmp     j1                  ;     ,     2.     ,     (     ) 
                                   ;    j1   

                                   ; : "     buf_X  ADC4?"
n1:	  sub      buf_X, ADC4         ;     buf_X  ADC4 
      cpi      buf_X, 2            ;      2,  ,    (     )
      brsh     f2                  ;    f2     buf_X  ADC4    2 
      rjmp     j1                  ;     ,     2.     ,     (     ) 
                                   ;    j1   
                
                             ;    ( )
							       
f1:   in       temp, PINB          ;         temp 
      sbrc     temp, 0 		       ; : "      .  0 = 0,         .
	  rjmp     f6                  ;  0 = 1,     
	  rjmp     j1                  ;  0 = 0,      

f6:   clr      rewers              ;      rewers  0 (     )	  
	  ldi      temp, 0b00001100    ;   0b00001100    
      out      TCCR2,temp          ;   2
	  sei                          ;     	
	  
	  out      PORTC, step         ;       step  PORTC (      ) 
      rjmp     j2                  ; : "  ,   ,       "?       j2
                             
							  ;    ( )

f2:   ldi      rewers, 1	  	   ;      rewers  1
	  ldi      temp, 0b00001100    ;   0b00001100    
      out      TCCR2,temp          ;   2
	  sei                          ;     
	  
	  out      PORTC, step         ;       step  PORTC (      )
      rjmp     j2                  ; : "  ,   ,       "?       j2
     					
					
						;       ( )							
old_st:  	                             
      cli                          ;     
	  ldi      step, 0b00000001    ;    step        

calibr2:                           ;         
      ldi      rab, 0b00100101     
      out	   ADMUX, rab          ;      -      ADC5      ADC5
      ldi      rab, 0b11000001     ;      1  (..   2        /2)
	  out      ADCSRA, rab         ;            
fd4:  in       rab, ADCSRA         ;     6  DSC   0 ( ),       ADC5 
	  sbrc     rab, 6              ;       /  2 - OCR2
	  rjmp     fd4
	  in       ADC5, ADCH   
	  out      OCR2, ADC5          ;      c ADC5
	  
	  in       temp, PINB          ;        temp     
      sbrc     temp, 1             ;   1     0 ( 0,   . )
	  rjmp     left_end2           ;  1=1,       ,       ,     1          
      clr      st_mot_X            ;  1=0,              .      st_mot_X 
	  rjmp     main2               ;      main2
	  					   
left_end2:                         
	  ldi      rewers, 1	       ;  1   rewers (             2)
	  ldi      temp, 0b00001100    ;   0b00001100    
      out      TCCR2,temp          ;    2 
	  sei                          ;     						    	  
	  ldi      step, 0b00000001    ;    step        

o1:   ldi      rab, 0b00100101     
      out	   ADMUX, rab          ;      -      ADC5      ADC5
      ldi      rab, 0b11000001     ;      1  (..   2        /2)
	  out      ADCSRA, rab         ;            
fd5:  in       rab, ADCSRA         ;     6  DSC   0 ( ),       ADC5 
	  sbrc     rab, 6              ;       /  2 - OCR2
	  rjmp     fd5
	  in       ADC5, ADCH   
	  out      OCR2, ADC5          ;      c ADC5

      mov      rab, step           ;     step   rab
      ldi      temp, 0xFF          ;     temp (  )
	  eor      rab, temp           ;   rab    " "   temp
	  ldi      temp, 0b00001111    ;      temp 
	  and      rab, temp           ;      rab   .        rab   temp
	  out      PORTC, rab  	  	   ;    ,           ,          					
	  
	                               ;     PORTC (      ) 
	  in       temp, PINB          ;        temp					
	  sbrc     temp, 1 		       ; : "        .  1 = 0,       .		
	  rjmp     o1                  ;  1=1,            1,     step          
	  clr      st_mot_X            ;  1=0,         .      st_mot_X   
      
v1:	  cli                          ;     					
      ldi      temp, 0b00001000    
      out      TCCR2, temp         ;   -  2
	  out      TCNT2, sbros        ;     -   2
  						
							;   ( ) 
							 
main2:ldi      rab, 0b00100101     
      out	   ADMUX, rab          ;      -      ADC5      ADC5
      ldi      rab, 0b11000001     ;      1  (..   2        /2)
	  out      ADCSRA, rab         ;            
fd3:  in       rab, ADCSRA         ;     6  DSC   0 ( ),       ADC5 
	  sbrc     rab, 6              ;       /  2 - OCR2
	  rjmp     fd3
	  in       ADC5, ADCH   
	  out      OCR2, ADC5          ;      c ADC5 	                              
      
	  ldi      rab, 0b00100100     ;                
      out	   ADMUX, rab          ;     -     ADC4      ADC4
      ldi      rab, 0b11000001     ;  X -   -     1  (..   2        /2)
	  out      ADCSRA, rab         ;            
m2:   in       rab, ADCSRA         ;     6  DSC   0 ( ),       ADC4 
	  sbrc     rab, 6              ;     .
	  rjmp     m2
      
v2:   cbi      PORTD, 7            ;   PD7 (  )
      cpi      st_mot_X, 0         ;  : "   st_mot_X -    "?
      breq     vd1                 ;  st_mot_X ,     vd1
      cbi      PORTD, 5            ;   st_mot_X  ,   D5  
      rjmp     vd2                 ;    vd2

vd1:  sbi      PORTD, 5            ;   st_mot_X  0,    D5 

vd2:  in       ADC4, ADCH          ;      ADCH   -  ADC4 
      cpi      ADC4, 0             ;    ADC4  0 
	  breq     j6                  ;     0,    -      ,            ;      j6 
	  rjmp     j7                  ;     0,          j7
j6:	  in       temp, PINB          ;        temp     
      sbrc     temp, 1             ;   1     0 ( 0,   . )
	  rjmp     left_end2           ;  1=1,          .    (  left_end2)	  
	  
j7:	  mov      buf_X, st_mot_X     ;   ADC4 > 0,        .          buf_X
      cp       ADC4, buf_X         ;    ADC4  buf_X (..      X -     )
      breq     v1                  ;    ,      -          ,     v1   
      brlo     n2                  ;    ADC4  buf_X,    n2
                                   ;        ADC4  buf_X,     ...
      
                                   ; : "     ADC4  buf_X?"
	  sub      ADC4,  buf_X        ;     ADC4  buf_X  
      cpi      ADC4, 2             ;      2,  ,    (     )
      brsh     e1                  ;    e1     ADC4  buf_X    2  
      rjmp     v1                  ;     ,     2.     ,     (     )
                                   ;    v1   
								   
                                   ; : "     buf_X  ADC4?"
n2:	  sub      buf_X, ADC4         ;     buf_X  ADC4 
      cpi      buf_X, 2            ;      2,  ,    (     )
      brsh     e2                  ;    e2     buf_X  ADC4    2 
      rjmp     v1                  ;     ,     2.     ,     (     )

                                   ;    ( )

e1:   in       temp, PINB          ;         temp 
      sbrc     temp, 0 		       ; : "      .  0 = 0,         . 
	  rjmp     e3                  ;  0 = 1,     
	  rjmp     v1                  ;  0 = 0,      

e3:   clr      rewers  	           ;      -     rewers  0
	  ldi      temp, 0b00001100    ;   0b00001100    
      out      TCCR2,temp          ;   2
	  sei                          ;     
	  
	  mov      rab, step           ;     step   rab
      ldi      temp, 0xFF          ;     temp (  )
	  eor      rab, temp           ;   rab    " "   temp
	  ldi      temp, 0b00001111    ;      temp
	  and      rab, temp           ;      rab   .        rab   temp
	  out      PORTC, rab          ;    ,           ,          
                                   ;     PORTC (      ) 
	  rjmp     v2                  ; : "  ,   ,       "?       v2
      
                                   ;    ( )

e2:   ldi      rewers, 1	  	   ;      -     rewers  1
	  ldi      temp, 0b00001100    ;   0b00001100    
      out      TCCR2,temp          ;   2
	  sei                          ;     
	  
	  mov      rab, step           ;     step   rab
      ldi      temp, 0xFF          ;     temp (  ) 
	  eor      rab, temp           ;   rab    " "   temp
	  ldi      temp, 0b00001111    ;      temp
	  and      rab, temp           ;      rab   .        rab   temp
	  out      PORTC, rab          ;    ,           ,          
      rjmp     v2                  ; : "  ,   ,       "?       v2
     							
diskret:   						
	  in       temp, PINB          ;         temp
	  sbrc     temp, 2             ;   2     0 ( 0,   .      mic_st)
	  rjmp     disk_old_st		   ;  2=1,     old_st					   						   
      ldi      step, 3             ;    step        


disk_mic_st:            ;       ( )

      cli                          ;     					
      ldi      temp, 0b00001000   
      out      TCCR2,temp          ;   -  2
	  out      TCNT2, sbros	       ;     -   2					
	  						
				;        
							  
jd12: cbi      PORTD, 7            ;   PD7 (  )
      cpi      st_mot_X, 0         ;  : "   st_mot_X -    "?
      breq     fd15                ;  st_mot_X ,     fd15
      cbi      PORTD, 5            ;   st_mot_X  ,   D5
      rjmp     fd16                ;    fd16

fd15: sbi      PORTD, 5            ;   st_mot_X  0,    D5  
      
fd16: ldi      rab, 0b00100101     
      out	   ADMUX, rab          ;      -      ADC5      ADC5
      ldi      rab, 0b11000001     ;      1  (..   2        /2)
	  out      ADCSRA, rab         ;            
fd10: in       rab, ADCSRA         ;     6  DSC   0 ( ),       ADC5 
	  sbrc     rab, 6              ;       /  2 - OCR2
	  rjmp     fd10
	  in       ADC5, ADCH   
	  out      OCR2, ADC5          ;      c ADC5
                                   
      in       temp, PIND          ;     D    temp       
      sbrc     temp, 1             ;     PD1,  PD1=0,   .       - "  "             
	  rjmp     jd13				   ;  PD1=1,    ;   	jd13      PD2	   
                            
							;    ( )

	  in       temp, PINB          ;         temp        	    		
      sbrc     temp, 0   		   ; : "     .  0 = 0,        (  disk_mic_st)			       
      rjmp     fd11                ;  PB0=1,     fd11
	  rjmp     disk_mic_st         ;  PB0=0,     disk_mic_st 

fd11: clr      rewers              ;      rewers  0 (     )	  
	  ldi      temp, 0b00001100    ;   0b00001100    
      out      TCCR2,temp          ;   2
	  sei                          ;     		  
	  out      PORTC, step         ;       step  PORTC (      ) 
      rjmp     jd12                ;     jd12

jd13: in       temp, PIND          ;         temp       
      sbrc     temp, 2             ;     PD2,  PD2=0,   .       - "  "             
	  rjmp     disk_mic_st	       ;  PD1=1  PD2=1,      disk_mic_st   

                          	;    ( )

	  in       temp, PINB          ;         temp        	    		
      sbrc     temp, 1   		   ; : "     .  1 = 0,        (  disk_mic_st)			       
      rjmp     fd12                ;  PB1=1,     fd12
	  rjmp     disk_mic_st         ;  PB1=0,     disk_mic_st 

fd12: ldi      rewers, 1	  	   ;      rewers  1
	  ldi      temp, 0b00001100    ;   0b00001100    
      out      TCCR2,temp          ;   2
	  sei                          ;     	  
	  out      PORTC, step         ;       step  PORTC (      )
      rjmp     jd12                ;     jd12
			
			
			    ;       ( )			   
disk_old_st:  
      cli                          ;     
	  ldi      step, 0b00000001    ;    step        

end1: cli                          ;     					
      ldi      temp, 0b00001000   
      out      TCCR2,temp          ;   -  2
	  out      TCNT2, sbros	       ;     -   2
	                       
gh1:  cbi      PORTD, 7            ;   PD7 (  )
      cpi      st_mot_X, 0         ;  : "   st_mot_X -    "? 
      breq     fd17                ;  st_mot_X ,     fd17
      cbi      PORTD, 5            ;   st_mot_X  ,   D5
      rjmp     fd18                ;    fd18

fd17: sbi      PORTD, 5            ;   st_mot_X  0,    D5 

fd18: ldi      rab, 0b00100101     
      out	   ADMUX, rab          ;      -      ADC5      ADC5
      ldi      rab, 0b11000001     ;      1  (..   2        /2)
	  out      ADCSRA, rab         ;            
fd14: in       rab, ADCSRA         ;     6  DSC   0 ( ),       ADC5 
	  sbrc     rab, 6              ;       /  2 - OCR2
	  rjmp     fd14
	  in       ADC5, ADCH   
	  out      OCR2, ADC5          ;      c ADC5
	  
	  in       temp, PIND          ;     D    temp       
      sbrc     temp, 1             ;     PD1,  PD1=0,   .       - "  "               
	  rjmp     gh2		           ;  PD1=1,    ;   	jh2      PD2
                           
						   ;    ( )

	  in       temp, PINB          ;         temp        	    		
      sbrc     temp, 0   		   ; : "     .  0 = 0,        (  end1)			       
      rjmp     gh3                 ;  PB0=1,     gh3
	  rjmp     end1                ;  PB0=0,     end1
      

gh3:  clr      rewers  	           ;      -     rewers  0
	  ldi      temp, 0b00001100    ;   0b00001100    
      out      TCCR2,temp          ;   2
	  sei                          ;     
	  
	  mov      rab, step           ;     step   rab
      ldi      temp, 0xFF          ;     temp (  )
	  eor      rab, temp           ;   rab    " "   temp
	  ldi      temp, 0b00001111    ;      temp
	  and      rab, temp           ;      rab   .        rab   temp
	  out      PORTC, rab          ;    ,           ,          
                                   ;     PORTC (      ) 
	  rjmp     gh1                 ; : "  ,   ,       "?       gh1
 
                                      
gh2:  in       temp, PIND          ;     D    temp       
      sbrc     temp, 2             ;     PD2,  PD2=0,   .       - "  "            
	  rjmp     end1                ;  PD1=1  PD2=1,      end1   
                                
								;    ( )

      in       temp, PINB          ;         temp        	    		
      sbrc     temp, 1   	  	   ; : "     .  1 = 0,        (  end1)				       
      rjmp     gh4                 ;  PB1=1,     gh4
	  rjmp     end1                ;  PB1=0,     end1
                                   

gh4:  ldi      rewers, 1	  	   ;      -     rewers  1
	  ldi      temp, 0b00001100    ;   0b00001100    
      out      TCCR2,temp          ;   2
	  sei                          ;     
	  
	  mov      rab, step           ;     step   rab
      ldi      temp, 0xFF          ;     temp (  ) 
	  eor      rab, temp           ;   rab    " "   temp
	  ldi      temp, 0b00001111    ;      temp
	  and      rab, temp           ;      rab   .        rab   temp
	  out      PORTC, rab          ;    ,           ,          
      rjmp     gh1                 ; : "  ,   ,       "?       gh1
     																   
						   
				    	 ;       /  2
                            
							       ;    (/ )
timer_2:in       temp, PINB        ;         temp        	    		
    	sbrc     temp, 2           ;   2     0 ( 0,   .      mic_tim)
	    rjmp     old_tim           ;  2=1,     old_tim

mic_tim:                           ;    
        cpi     rewers, 1          ;    -      1
		breq    t2                 ;      1,       
                                   ;         0.        
							   
							   ;       
                                  
                                   ;      -  step
t1:  	cpi     step, 7            ;       -   0b00000111 
        breq    p1                 ;  ,         p1;    ,    
		cpi     step, 3            ;       -   0b00000011
	    breq    p2                 ;  ,         p2;    ,    
        cpi     step, 11           ;       -   0b00001011
        breq    p3                 ;  ,         p3;    ,     
		cpi     step, 9            ;       -   0b00001001  
	    breq    p4                 ;  ,         p4;    ,    
        cpi     step, 12           ;       -   0b00001100
	    breq    p5                 ;  ,         p5;    ,    
        cpi     step, 14           ;       -   0b00001110
        breq    p6                 ;  ,         p6;    ,    		
	    rjmp    p7                 ;        ,     -  : 0b00000110.         p7

p1:     ldi     step, 3            ;     -  step: 0b00000011 
        rjmp    exe_1              ;     exe_1
p2:     ldi     step, 11           ;     -  step: 0b00001011
        rjmp    exe_1              ;     exe_1
p3:     ldi     step, 9            ;     -  step: 0b00001001
        rjmp    exe_1              ;     exe_1 
p4:     ldi     step, 12           ;     -  step: 0b00001100
        rjmp    exe_1              ;     exe_1
p5:     ldi     step, 14           ;     -  step: 0b00001110
        rjmp    exe_1              ;     exe_1
p6:     ldi     step, 6            ;     -  step: 0b00000110
        rjmp    exe_1              ;     exe_1
p7:     ldi     step, 7            ;     -  step: 0b00000111
                                   ;     exe_1
exe_1:  cpi     st_mot_X, 255 	   ;   st_mot_X    - 255	
		breq    p9                 ;  ,     p9
        
		inc     st_mot_X           ;   ,       st_mot_X 
        
		rjmp    p10                ;    p10

p9:  	clr     st_mot_X           ;  st_mot_X
        		
p10:    sbi     PORTD, 7           ;      PD7=1 -  / 
        cbi     PORTD, 6      	   ;      PD6=0 -     

		reti                       ;    
                            
							 ;       

                                   ;      -  step
t2:		cpi     step, 6            ;       -   0b00000110 
	    breq    a7                 ;  ,         7;    ,    
        cpi     step, 14           ;       -   0b00001110
        breq    a6                 ;  ,         6;    ,     
        cpi     step, 12           ;       -   0b00001100 
	    breq    a5                 ;  ,         5;    ,     
		cpi     step, 9            ;       -   0b00001001 
	    breq    a4                 ;  ,         4;    ,    
        cpi     step, 11           ;       -   0b00001011
        breq    a3                 ;  ,         3;    ,    
        cpi     step, 3            ;       -   0b00000011
	    breq    a2                 ;  ,         2;    ,    
        rjmp    a1                 ;        ,     -  : 0b00000110.         1


a7:     ldi     step, 14           ;     -  step: 0b00001110
        rjmp    exe_2              ;     exe_2
a6:     ldi     step, 12           ;     -  step: 0b00001100
        rjmp    exe_2              ;     exe_2
a5:     ldi     step, 9            ;     -  step: 0b00001001
        rjmp    exe_2              ;     exe_2
a4:     ldi     step, 11           ;     -  step: 0b00001011
        rjmp    exe_2              ;     exe_2
a3:     ldi     step, 3            ;     -  step: 0b00000011
        rjmp    exe_2              ;     exe_2
a2:     ldi     step, 7            ;     -  step: 0b00000111  
        rjmp    exe_2              ;     exe_2
a1:     ldi     step, 6            ;     -  step: 0b00000110
                                   ;     exe_2
exe_2:  cpi     st_mot_X, 0        ;   st_mot_X    - 0
   	    breq    a8                 ;  ,     8
        
		dec     st_mot_X           ;   ,       st_mot_X
	    rjmp    a9                 ;    9

a8:     ldi     st_mot_X, 255      ;   st_mot_X   - 255
		
a9:		sbi     PORTD, 7           ;      PD7=1 -  /
        sbi     PORTD, 6      	   ;      PD6=1 -    
		
		reti                       ;    

old_tim:                           ;    
		cpi     rewers, 1          ;    -      1
		breq    x4                 ;      1,        
                                   ;         0.        
                       
					    ;       
        
x1:	    sbrs    step, 0            ; : "         step;  ,    
        rjmp    x2                 ;   ,     x2
		ldi     step, 0b00001000   ;        step 
	    rjmp    x3                 ;     3 
x2:     lsr     step               ;    step      	     

x3:     cpi     st_mot_X, 255      ;   st_mot_X    - 255
        breq    x7                 ;  ,     7
		
		inc     st_mot_X           ;   ,       st_mot_X 
        rjmp    x8                 ;    8

x7:  	clr     st_mot_X           ;  st_mot_X   

x8:		sbi     PORTD, 7           ;      PD7=1 -  / 
        cbi     PORTD, 6      	   ;      PD6=0 -    		        
		
		reti                       ;     
 
                       ;       

x4:		sbrs    step, 3            ; : "         step;  ,    
        rjmp    x5                 ;   ,     x5
		ldi     step, 0b00000001   ;        step 
	    rjmp    x6                 ;     6
x5:     lsl     step               ;    step      	     
        
x6:     cpi     st_mot_X, 0        ;   st_mot_X    - 0
   	    breq    x9                 ;  ,     9 
        
        dec     st_mot_X           ;   ,       st_mot_X
 	    rjmp    x10                ;    10

x9:     ldi     st_mot_X, 255      ;   st_mot_X   - 255
		
x10:	sbi     PORTD, 7           ;      PD7=1 -  / 
        sbi     PORTD, 6      	   ;      PD6=0 -    

		reti                       ;    

  

